<?php
/*
   Limph Is Monitoring Pingable Hosts
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once "Net/Ping.php";

$version = "1.9.8.2";

if(!(function_exists('mysql_real_escape_string'))){ 
  function mysql_real_escape_string($value){ 
    return mysql_escape_string($value); 
  } 
 }; 

function limph_key(){
  echo "<table border=0 align=center>";
  echo "<tr><th>Key:</th><td bgcolor=#00FF00>Up</td><td bgcolor=#FFA500>Warning</td><td bgcolor=#FF0000>Down</td><td bgcolor=#FF00FF>Unreachable</td><td bgcolor=#808080>Disabled</td></tr>";
  echo "</table>";
};
  
function dbms_fetch_array($result, $type){
  global $dbtype;
  if($dbtype=="my"){
    if($type=="NUM"){$line = mysql_fetch_array($result, MYSQL_NUM);};
    if($type=="ASSOC"){$line = mysql_fetch_array($result, MYSQL_ASSOC);};
    if($type=="BOTH"){$line = mysql_fetch_array($result, MYSQL_BOTH);};
  };
  if($dbtype=="pg"){
    if($type=="NUM"){$line = pg_fetch_array($result, NULL, PGSQL_NUM);};
    if($type=="ASSOC"){$line = pg_fetch_array($result, NULL, PGSQL_ASSOC);};
    if($type=="BOTH"){$line = pg_fetch_array($result, NULL, PGSQL_BOTH);};
  };
  if($dbtype=="sl"){
    global $link;
    #if($type=="NUM"){$line = sqlite_fetch_array($result, NULL, SQLITE_NUM);};
    #if($type=="ASSOC"){$line = sqlite_fetch_array($result, NULL, SQLITE_ASSOC);};
    #if($type=="BOTH"){$line = sqlite_fetch_array($result, NULL, SQLITE_BOTH);};
    $line = sqlite_fetch_array($result, NULL);
    #if($type=="NUM"){$result->setFetchMode(PDO::FETCH_NUM);};
    #if($type=="ASSOC"){$result->setFetchMode(PDO::FETCH_ASSOC);};
    #if($type=="BOTH"){$result->setFetchMode(PDO::FETCH_BOTH);};
    #$line = $result->fetch();
  };
  if($dbtype=="slpdo"){
    global $link;
    #if($type=="NUM"){$line = sqlite_fetch_array($result, NULL, SQLITE_NUM);};
    #if($type=="ASSOC"){$line = sqlite_fetch_array($result, NULL, SQLITE_ASSOC);};
    #if($type=="BOTH"){$line = sqlite_fetch_array($result, NULL, SQLITE_BOTH);};
    #$line = sqlite_fetch_array($result, NULL);
    #if($type=="NUM"){$result->setFetchMode(PDO::FETCH_NUM);};
    #if($type=="ASSOC"){$result->setFetchMode(PDO::FETCH_ASSOC);};
    #if($type=="BOTH"){$result->setFetchMode(PDO::FETCH_BOTH);};
    $line = $result->fetch();
  };
  return $line;
};

function dbms_free_result($result){
  global $dbtype;
  if($dbtype=="my"){
    mysql_free_result($result);    
  };
  if($dbtype=="pg"){
    pg_free_result($result);
  };
};
  
function dbms_query($query){  
  global $dbtype;
  if($dbtype=="my"){
    $result = mysql_query($query);
  };
  if($dbtype=="pg"){
    $result = pg_query($query);
  };
  if($dbtype=="sl"){
    global $link;
    $result = sqlite_query($query, $link);
  };
  if($dbtype=="slpdo"){
    global $link;
    $result = $link->query($query);
  };
  return $result;
};
  
function dbms_escape_string($string){
  global $dbtype;
  if($dbtype=="my"){
    $string = mysql_real_escape_string($string);
  };
  if($dbtype=="pg"){
    $string = pg_escape_string($string);
  };
  return $string;    
};

function dbms_close($link){
  global $dbtype;
  if($dbtype=="my"){
    mysql_close($link);
  };
  if($dbtype=="pg"){
    pg_close($link);
  };
  if($dbtype=="sl"){
    $link = null;
  };
  if($dbtype=="slpdo"){
    $link = null;
  };
};

function dbms_connect($dbhost, $dbuser, $dbpass, $dbname){
  global $dbtype;
  global $dbpath; //test for Robi
  if($dbtype=="my"){
    $link = mysql_connect($dbhost, $dbuser, $dbpass);
    mysql_select_db($dbname);
  };
  if($dbtype=="pg"){
    $link = pg_connect("host=$dbhost dbname=$dbname user=$dbuser password=$dbpass");
  };
  if($dbtype=="sl"){
    $link = sqlite_open($dbpath);
  };
  if($dbtype=="slpdo"){
    $string = 'sqlite:' . $dbpath;
    $link = new PDO($string);
  };
  return $link;
}; 

function sysload_thresh_check($hostname, $value){
  $return = 0;
  $query2 = "SELECT value FROM thresholds WHERE hostname = '$hostname' AND type = 'sysload';";
  $result2 = dbms_query($query2);
  $line2 = dbms_fetch_array($result2, "ASSOC");
  dbms_free_result($result2);
  
  $thresh_bits = explode("#", $line2['value']);
  $data_bits = explode("#", $value);
  
  if($data_bits[0]>$thresh_bits[0]||$data_bits[1]>$thresh_bits[1]||$data_bits[2]>$thresh_bits[2]){
    $return=1;
  };

  return $return;

};

function disk_thresh_check($hostname, $disk, $value){
  $return = 0;
  $query2 = "SELECT value FROM thresholds WHERE hostname = '$hostname' AND disk = '$disk' AND type = 'diskfree';";
  $result2 = dbms_query($query2);
  $line2 = dbms_fetch_array($result2, "ASSOC");
  dbms_free_result($result2);
  
  if($value<$line2['value']){ $return = 1; };
  
  return $return;
};

function favicon(){
  echo "<link rel=\"shortcut icon\" href=\"favicon.png\" type=\"image/x-icon\">";
};

function authentication($flag_me, $level){
  session_start();
  if((!isset($_SESSION['limphstate']))||(!isset($_SESSION['limphid']))||($flag_me < $level)){
    echo"Try logging in. . .\n";
    global $siteaddress;
    echo "<meta http-equiv=refresh content=5;url=$siteaddress/index.php />";
    exit;
  }
}

function udp_ping($host, $timeout){
#Inspired by Simon Riget's 11/17/2004 post to php.net
  
  //open
  $sock=fsockopen('udp://'.$host, 7, $errno, $errstr, $timeout);
  if (!$sock){
    //store errno
    $status = "0";
  } else {
    stream_set_timeout($sock, $timeout); 
    //send somthing
    $write=fwrite($sock, "AYBABTU\n");
    if(!$write){
      //capture write error to db
      break;
    };
    //try to get something back
    fread($sock,8);
    $info = stream_get_meta_data($sock);
    if($info['timed_out']){
      $status = "0";
    } else {
      $status = "1";
    };
    fclose($sock);
  };
  return $status;
};

function tcp_check($host, $timeout, $port){
  
  //open
  if($sock=fsockopen($host, $port, $errno, $errstr, $timeout)){
    $status = "1";
    fclose($sock);
  } else {
    $status = "0";
  };
  
  return $status;
};

function icmp_check($host){
  $ping = Net_Ping::factory();
  if (PEAR::isError($ping)) {
    $status = "0";
  } else {
    $ping->setArgs(array('count' => 1, 'timeout' => 1));
    $status = $ping->ping($host)->_received;
  };
  
  return $status;
};

function host_check($type, $host, $timeout, $port){
  if($type=="udp"){
    $status = udp_ping($host, $timeout);
  };
  if($type=="tcp"){
    $status = tcp_check($host, $timeout, $port);
  };
  if($type=="icmp"){
    $status = icmp_check($host);
  };

  return $status;
};

function valid_date($fodder){
  $chunks = explode("-", $fodder);
  $answer = checkdate($chunks[1], $chunks[2], $chunks[0]);
  return $answer;
};

function parent_check($parent, $number){
  if($parent==$number){ return 0; };
  $orig = $parent;
  while($parent != 0){
    $query = "SELECT parent FROM hosts WHERE number = '$parent';";
    $result = dbms_query($query);
    $line = dbms_fetch_array($result, "NUM");
    dbms_free_result($result);
    
    if($line[0]==$number){ return 0; };

    $parent = $line[0];
  };

  return $orig;
};

function button_image($text, $back, $length){
  $width = "20";
  
  #if($back=="grey"){$back_color=array(204, 204, 204);};
  #if($back=="white"){$back_color=array(255, 255, 255);};

  header("Content-type: image/png");
  #$im = @imagecreate($length, $width)
  #   or die("Cannot Initialize new GD image stream");
  $file = $back . "_" . $width . "x" . $length . "_bevel.png";
  $im = imagecreatefrompng($file);
  $blue = imagecolorallocate($im, 0, 0, 255);
  $black = imagecolorallocate($im, 0, 0, 0);
  
  #$background = imagecolorallocate($im, $back_color[0], $back_color[1], $back_color[2]);
  #imagefilledrectangle($im, 0, 0, $length-1, $width-1, $background);

  imagestring($im, 3, 5, 5, $text, $black);

  imagepng($im);
  imagedestroy($im);

};

function limph_db_upgrade($oldversion, $version){
  global $dbtype;
  
  $query = "UPDATE universal SET version = '$version';";
  dbms_query($query);
  
  if($dbtype=="my"){
    if($oldversion<="1.1"){
      $query = "ALTER TABLE `groups` ADD `collapse` ENUM('0', '1') NOT NULL;";
      dbms_query($query);
      
      $query = "UPDATE `hosts` SET `collapse` = '0' WHERE collapse IS NULL;";
      dbms_query($query);
      
    };
    
    if($oldversion<="1.2"){
      $query = "ALTER TABLE `universal` ADD `textsize` ENUM('xx-small', 'x-small', 'small', 'medium', 'large', 'x-large', 'xx-large') DEFAULT 'small' NOT NULL ;";
      dbms_query($query);
      
      $query = "ALTER TABLE `universal` ADD `tabletextsize` ENUM('xx-small', 'x-small', 'small', 'medium', 'large', 'x-large', 'xx-large') DEFAULT 'x-small' NOT NULL ;";
      dbms_query($query);
      
      $query = "ALTER TABLE `universal` ADD `autoupdateip` ENUM('0', '1') NOT NULL AFTER `year`;";
      dbms_query($query);
    };
    
    if($oldversion<="1.3"){
      $query = "ALTER TABLE `history` ADD `host` SMALLINT(6) NOT NULL AFTER `hostname` ;";
      dbms_query($query);
      
      $query = "UPDATE history,hosts SET history.host = hosts.number WHERE hosts.name = history.hostname;";
      dbms_query($query);
      
      $query = "ALTER TABLE `hosts` ADD `parent` SMALLINT(6) NOT NULL;";
      dbms_query($query);
    
      $query = "ALTER TABLE `hosts` ADD `visible` ENUM('1', '0') NOT NULL;";
      dbms_query($query);
    };
    
    if($oldversion<="1.4"){
      $query = "ALTER TABLE `hosts` CHANGE `group` `hostgroup` SMALLINT(4) NOT NULL DEFAULT '0';";
      dbms_query($query);
      
      $query = "ALTER TABLE `groups` CHANGE `collapse` `collapse` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0';";
      dbms_query($query);
      
      $query = "ALTER TABLE `history` CHANGE `host` `host` INT(6) NOT NULL DEFAULT '0';";
      dbms_query($query);
      
      $query = "ALTER TABLE `history` CHANGE `type` `type` VARCHAR(4) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'Up';";
      dbms_query($query);
      
      $query = "ALTER TABLE `hosts` CHANGE `number` `number` INT(6) NOT NULL DEFAULT '0';";
      dbms_query($query);
      
      $query = "ALTER TABLE `hosts` CHANGE `status` `status` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1',
CHANGE `enabled` `enabled` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1',
CHANGE `type` `type` VARCHAR(3) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'udp',
CHANGE `visible` `visible` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1';";
      dbms_query($query);
      
      $query = "ALTER TABLE `universal` CHANGE `notify` `notify` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0',
CHANGE `autoupdateip` `autoupdateip` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0',
CHANGE `textsize` `textsize` VARCHAR(8) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'small',
CHANGE `tabletextsize` `tabletextsize` VARCHAR(8) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT 'x-small';";
      dbms_query($query);
      
      $query = "ALTER TABLE `users` CHANGE `number` `number` INT(6) NOT NULL DEFAULT '0',
CHANGE `admin` `admin` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '0',
CHANGE `notify` `notify` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1',
CHANGE `digest` `digest` VARCHAR(1) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT '1';";
      dbms_query($query);
    };
    
    if($oldversion<="1.8.2"){
      $query = "CREATE TABLE `state` (`number` INT NOT NULL, `datetime` DATETIME NOT NULL, `hostname` VARCHAR(40) NOT NULL, `type` VARCHAR(20) NOT NULL, `data` VARCHAR(50) NOT NULL, `disk` VARCHAR(20) NOT NULL, PRIMARY KEY ( `number` )) ENGINE = MYISAM;";
      dbms_query($query);
      
      $query = "CREATE TABLE `thresholds` (`number` INT NOT NULL, `hostname` VARCHAR(50) NOT NULL, `type` VARCHAR(20) NOT NULL, `value` VARCHAR(20) NOT NULL, `disk` VARCHAR(20) NOT NULL, PRIMARY KEY (`number`)) ENGINE = MYISAM;";
      dbms_query($query);
    };
    
    if($oldversion<="1.9.2"){
      $query = "ALTER TABLE `universal` ADD `status_public` VARCHAR(1) NOT NULL DEFAULT '0';";
      dbms_query($query);
      
      $query = "CREATE TABLE `host_notif` (`number` INT(10) NOT NULL, `host` INT(6) NOT NULL, `user` INT(6) NOT NULL, PRIMARY KEY ( `number` )) ENGINE = MYISAM ;";
      dbms_query($query);
    };

    if($oldversion<="1.9.4"){
      $query = "ALTER TABLE `hosts` CHANGE `type` `type` CHAR(4) NOT NULL DEFAULT 'icmp';";
      dbms_query($query);

      $query = "ALTER TABLE `history` ADD FULLTEXT `fulltext.his.hos` ( `hostname`);";
      dbms_query($query);

      $query = "ALTER TABLE `state` ADD FULLTEXT `fulltext.sta.hos` ( `hostname`);";
      dbms_query($query);
    };

    if($oldversion<="1.9.6"){
      $query = "ALTER TABLE `hosts` ADD `autoupdateip` CHAR(1) NOT NULL DEFAULT '0';";
      dbms_query($query);
    };


  } else {
    
    if($oldversion<="1.8.2"){
      $query = "CREATE TABLE state (number integer NOT NULL, datetime timestamp without time zone NOT NULL, hostname character varying NOT NULL, \"type\" character varying NOT NULL, data character varying NOT NULL, disk character varying NOT NULL);";
      dbms_query($query);
      
      $query = "ALTER TABLE ONLY state ADD CONSTRAINT \"state.number\" PRIMARY KEY (number);"; $query = "ALTER TABLE ONLY state ADD CONSTRAINT \"state.number\" PRIMARY KEY (number);";
      
      $query = "CREATE TABLE thresholds (number INT NOT NULL, hostname character varying NOT NULL, type character varying NOT NULL, value character varying NOT NULL, disk character varying NOT NULL;";
      dbms_query($query);
      
      $query = "ALTER TABLE ONLY thresholds ADD CONSTRAINT \"thresholds.number\" PRIMARY KEY (number);";
    };

    if($oldversion<="1.9.2"){
      $query = "ALTER TABLE ONLY universal ADD COLUMN status_public character varying NOT NULL;";
      dbms_query($query);
      
      $query = "CREATE TABLE host_notif (number integer NOT NULL, host integer NOT NULL, user integer NOT NULL;";
      dbms_query($query);
      
      $query = "ALTER TABLE ONLY host_notif ADD CONSTRAINT \"host_notif.number\" PRIMARY KEY (number);";
      dbms_query($query);
    };

    if($oldversion<="1.9.4"){
      $query = "ALTER TABLE `hosts` ALTER COLUMN `type` TYPE character varying(4) NOT NULL DEFAULT 'icmp';";
      dbms_query($query);
    };

    if($oldversion<="1.9.6"){
      $query = "ALTER TABLE ONLY `hosts` ADD COLUMN autoupdateip character varying(1) NOT NULL DEFAULT 0";
      dbms_query($query);
    };

    if($oldversion<="1.9.7"){
      $query = "ALTER TABLE `hosts` CHANGE `ip` `ip` VARCHAR( 39 ) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL DEFAULT ''";
      dbms_query($query);
    };

  };
    
};

?>
